﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=7.01
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
#End Region

Sub Process_Globals
	Private cache As Map
	Private tasks As Map
	Private ongoingTasks As Map
	Private bc As ByteConverter
	Private su As StringUtils
End Sub

Sub Service_Create
	tasks.Initialize
	cache.Initialize
	ongoingTasks.Initialize
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

Sub Service_Destroy
End Sub

Sub Download (info As Map)
	Dim base64 As String = su.EncodeBase64(bc.StringToBytes(info.Get("URL"),"UTF8"))
	base64 = base64.Replace("=","")
	If File.Exists(File.DirInternal,base64&".jpg") Then
		Log($"file already exists. Use the downloaded image for ${info.Get("URL")}})"$)
		Dim bmp As Bitmap
		Log($"bmp.initialize(${File.DirInternal},${base64&".jpg"}}})"$)
		bmp.Initialize(File.DirInternal,base64&".jpg")
		Dim img As ImageView = info.Get("ImageView")
		img.Bitmap = bmp
	Else
		Log($"Download(${info.Get("URL")},${info.Get("ImageView")})"$)
		Dim j As HttpJob
		j.Initialize("ImageDownload", Me)
		j.Tag = info.Get("ImageView")
		j.Download(info.Get("URL"))
		Wait For (j) JobDone(j As HttpJob)
		If j.Success Then
			Log($"DownloadSuccess(${info.Get("URL")})"$)
			'The result is a json string. We parse it and log the fields.
			Dim MyStream As OutputStream = File.OpenOutput(File.DirInternal, base64&".jpg", False)
			File.Copy2(j.GetInputStream,MyStream) ' save the file
			Dim bmp As Bitmap = j.GetBitmap
			Log(bmp)
			Dim img As ImageView = info.Get("ImageView")
			Log(img)
			img.Bitmap = bmp
		Else
			Log($"JobError: ${j.ErrorMessage}"$)
		End If
		j.Release
	End If
	
End Sub

'Sub JobDone(Job As HttpJob)
'	ongoingTasks.Remove(Job.JobName)
'	If Job.Success Then
'		Dim bmp As Bitmap = Job.GetBitmap
''		If cache.Get(Job.JobName) <> Null Then
''			Log(Job.JobName & " dejà dans le cach")
''		Else
'			cache.Put(Job.JobName, bmp)
'			'Log(Job.JobName)
'			If tasks.IsInitialized Then
'				For i = 0 To tasks.Size - 1
'					Dim link As String = tasks.GetValueAt(i)
'					If link = Job.JobName Then
'						Dim iv As ImageView = tasks.GetKeyAt(i)
'						iv.SetBackgroundImage(bmp)
'						'Log(i)
'					End If
'				Next
'			End If
''		End If
'	Else
'		Log("Error downloading image: " & Job.JobName & CRLF & Job.ErrorMessage)
'	End If
'	Job.Release
'End Sub

Sub ActivityIsPaused
	tasks.Clear
End Sub
